<?php // $Id: act_lib.php,v 1.22 2004/10/11 10:42:42 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required PHP version:
 * >= 5.0.0 (wegen mysqli extension)
 * >= 4.3.0 (wegen debug_backtrace())
 *
 * Required files:
 * -
 *
 * Parameter:
 * -
 *
 */


// Wenn gettext nicht geladen wurde, Ersatzfunktion definieren
// Ohne gettext gibt es applanix nur auf Englisch!
if( !extension_loaded( 'gettext' ) ) {
    function _( $string ) {
        return $string;
    }

    // Dummy-Funktionen
    function bindtextdomain( $domain = '', $locale = '' ) {}
    function textdomain( $domain = '' ) {}
}

// Wenn PHP < 4.3.0, dann Dummy fuer debug_backtrace() definieren
if( !function_exists( 'debug_backtrace' ) ) {
    function debug_backtrace() {}
}

function apxMenuItem( $a_menu_item, $b_showtext = false ) {
    // $a_menu_item, (STRING)ARRAY[6]

    // fuer andere Browser: width="" height="" angeben

    global $apx_imgpath;

    if( trim( $a_menu_item[ 0 ] ) != '' ) {
        echo( '<a class="mgtitle" href="'.$a_menu_item[ 0 ].
              '" '.$a_menu_item[ 4 ].'><img src="'.$apx_imgpath.$a_menu_item[ 1 ].
              '" title="'.$a_menu_item[ 2 ].
              '" onMouseover="return dispStatus(\''.$a_menu_item[ 2 ].
              '\')" onMouseout="return dispStatus(\'\')">'.
              ( $b_showtext ? ' '.$a_menu_item[ 5 ] : '' )
              ."</a> \n" );
    }

    if( !$b_showtext )
        echo( $a_menu_item[ 3 ] );
}

function apxIsInArray( $arrayname, $varname, $vartoset = '', $default = 0,
                       $strict = false, $strict_val = '' ) {
    global $$vartoset;
    global $$arrayname;

    if( isset( ${$arrayname}[ $varname ] ) &&
        ( $strict ?
          ( trim( $strict_val ) != '' ?
            trim( ${$arrayname}[ $varname ] ) == $strict_val :
            trim( ${$arrayname}[ $varname ] ) != ''
          ) :
          true ) ) {
        if( trim( $vartoset ) != '' ) { $$vartoset = ${$arrayname}[ $varname ]; }
        return true;
    }
    else {
        if( trim( $vartoset ) != '' ) { $$vartoset = $default; }
        return false;
    }
}

function apxIsPost( $postvar, $vartoset = '', $default = 0, $strict = false, $strict_val = '' ) {
    return apxIsInArray( '_POST', $postvar, $vartoset, $default, $strict, $strict_val );
}

function apxIsGet( $getvar, $vartoset = '', $default = 0, $strict = false, $strict_val = '' ) {
    return apxIsInArray( '_GET', $getvar, $vartoset, $default, $strict, $strict_val );
}

function apxIsCookie( $cookievar, $vartoset = '', $default = 0, $strict = false, $strict_val = '' ) {
    return apxIsInArray( '_COOKIE', $cookievar, $vartoset, $default, $strict, $strict_val );
}

function apxIsPostGet( $postvar, $getvar = '', $vartoset = '',
                       $default = 0, $strict = false, $strict_val = ''  ) {
    if( empty( $getvar ) )
        $getvar = $postvar;

    // wenn get-Var existiert, dann aufhoeren
    $bGet = apxIsGet( $getvar, $vartoset, $default, $strict, $strict_val );

    if( !$bGet )
        $bPost = apxIsPost( $postvar, $vartoset, $default, $strict, $strict_val );

    return $bGet || $bPost;
}

function apxIsPostGetSame( $postgetvar, $vartoset = '',
                           $default = 0, $strict = false  ) {
    return apxIsPostGet( $postgetvar, $postgetvar, $vartoset, $default,
                         $strict, $strict_val );
}

/* guard for file include vulnerabilities and other security issues 
 * e. g. APX_Root_Path Parameter Multiple Remote File Include Vulnerabilities
 */
function apxGuard( $var_to_watch ) {
  if( apxIsPostGet( $var_to_watch ) || apxIsCookie( $var_to_watch ) ) {
  	trigger_error( _( "mg.applanix security: Possible intrusion or security hole exploit detected." ) );
  	exit( "<br />"._( "Interpretation of PHP has stopped." )."<br />\n</body></html>\n" );
  }
}

/* error handler */
function apxMsg( $errno, $errstr, $errfile, $errline ) {
    global $apx_imgpath;
    global $apx_debug_before_header;

    // Ausgabe vor dem HTTP-Header unterdrcken
    if( !$apx_debug_before_header && !headers_sent() )
        return;

    $sTitleCSS  = 'apx_headerbg';
    $sMsg       = "<br />(".sprintf( _( "In line %1\$s of file %2\$s" ),
                  $errline, $errfile ).", PHP ".
                  PHP_VERSION." (".PHP_OS."))\n" /*.
                  "[Debug-Backtrace:<br/><pre>".
                  var_dump(debug_backtrace())."</pre>]" */;
    $sHeader    = 'PHP-';

    switch( $errno ) {
    case E_USER_ERROR:
        $sMsg = '';
        $sHeader = _( 'applanix error' );
        $sTitleCSS = 'apx_errorbg';
        break;
    case E_USER_WARNING:
        $sMsg = '';
        $sHeader = 'applanix ';
    case E_WARNING:
        $sTitleCSS = 'apx_errorbg';
        $sHeader .= _( 'Warning' );
        break;
    case E_USER_NOTICE:
        $sMsg = '';
        $sHeader = _( 'applanix message' );
        break;
    case E_STRICT:   // beide ignorieren
    case E_NOTICE:
        return;
    default:
        $sHeader = _( 'Unknown type of message' );
        $sTitleCSS = 'apx_errorbg';
    }

    echo( "<div align=\"center\" class=\"wide\">
           <table class=\"apx_error\"><tr><td class=\"$sTitleCSS\">" );

    if( $apx_imgpath != '' )
        echo ( "<img src=\"".$apx_imgpath."sym_message.gif\" />" );
    else
        echo ( "<span class=\"mgsubtitle\">&nbsp;!&nbsp;</span>" );

    echo( "</td><td width=\"100%\" class=\"$sTitleCSS\">" );
    echo( "<span class=\"mgsubtitle\">$sHeader</span></td></tr>
           <tr><td colspan=\"2\" class=\"apx_mainbg\">$errstr$sMsg
           </td></tr></table></div>" );

    if( $errno == E_USER_ERROR ) {
        exit( "<br />"._( "Interpretation of PHP has stopped." )."<br />\n</body></html>\n" );
    }
}


/*  createLink - erzeugt einen einheitlichen Linkstring
 *  mit Hilfe von $mgs_lnktemplate
 */
function apxCreateLink( $template, $url, $text, $class ) {
    $template = str_replace ( "%url%", $url, $template );
    $template = str_replace ( "%text%", $text, $template );
    $template = str_replace ( "%class%", $class, $template );
    echo ( $template );
}


/*
 *  spezielle Funktion zur Generierung von Hilfelinks
 *  in der Konfiguration dsp_form_config.php
 */
function apxGenHelpLink( $cfgDirective ) {
    $template = '<a target="_blank" class="mgtxtsmall"
                 href="dsp_help_config.php?standalonecfg=1#'.
                $cfgDirective.
                '">['._( "Help" ).']</a>';
    apxCreateLink( $template, '', '', '' );
}


/* Funktion zur automatischen Weiterleitung auf drei Arten */
function apxAutoredirect( $sUrl, $sType = 'javascript/link', $sLinktext = 'Weiter' ) {

    echo '<div align="center" class="wide">';

    switch( $sType ) {
      case 'javascript':
        echo '<script language="javascript">location.href = "'.$sUrl.'";</script>';
        break;

      // Per HTTP ist nur ganz am Anfang einer Seite moeglich!
      case 'http':
        header( "Location: ".$sUrl );
        exit;

      case 'javascript/link':
        echo( _( 'If your browser supports javascript, you will be redirected to the next page automatically. Use the following link if you explore problems: ' ) );
        echo( '<a href="'.$sUrl.'">'.$sLinktext.'</a>.');
        echo( "<script language=\"javascript\">\n
               <!-- \n window.location.href = \"".$sUrl.
               "\"; \n //--></script>");
        break;

      default:
        trigger_error( _( "This type of redirection is not supported" ), E_USER_WARNING );
    }

    echo '</div>';
}

/* zur Ausgabe von Freibereichszellen im Applanix-Uebersichtsplan */
function apxPrintEmptySpace( $iColspan, $room_id, $uts_date, $uts_offset,
                             $sCellMode = 'connect', $b_showinfo = true ) {
    global $apx_imgpath;

    $s_emptystr = "<a href=\"$apx_script?apx_a=booking&do=i&rid=$room_id&ds=$uts_date&de=".
                  ( $uts_date + $uts_offset )."\"
                  title=\""._( "Create new booking" )."\"><span class=\"apx_plan\"
                  style=\"font-weight:lighter\">\n
                  <img src=\"${apx_imgpath}sym_new.gif\" title=\"".
                  _( "[new booking]" )."\" /></span></a>";

    if( $iColspan > 0 ) {
        if( $sCellMode == 'connect' ) {
            echo( '<td class="apx_mainbg" colspan="'.$iColspan.'">'.
                  ( $b_showinfo ? $s_emptystr : '&nbsp;' )."</td>\n" );
        }
        elseif( $sCellMode == 'split' ) {
            for( $i = 0; $i < $iColspan; $i++ ) {
                if( $i || !$b_showinfo )
                    echo( "<td class=\"apx_mainbg\">&nbsp;</td>\n" );
                else
                    echo( "<td class=\"apx_mainbg\">$s_emptystr</td>\n" );
            }
        }
    }
}


/*
 * Funktion zur Verhuellung der Datenbankabhaengigkeit zw. MySQL u. Access
 * Case-insensitive Stringsearch.
 */
function apxDb_retInstr( $sStr, $sSubstr, $dbSys ) {
    if ( $dbSys == 'mysqli' )
        return 'INSTR( UPPER( '.$sStr.' ), UPPER( \''.$sSubstr.'\' ) )';
    elseif ( $dbSys == 'odbc' )
        return 'instr( 1, '.$sStr.', \''.$sSubstr.'\', 1 )';
    else
        return '';
}

function apxDBstrcmp( $field, $value, $case = false ) {
    global $apx_dbsys;

    if( !$case ) {
        switch( $apx_dbsys ) {
        case 'mysqli': $s_comp = 'UPPER'; break;
        case 'odbc':  $s_comp = 'UCASE'; break;
        default:      $s_comp = '';
        }
    }

    return "$s_comp( $field ) = $s_comp( '$value' )";
}

/*
 * fuegt ein Zeichen einem nicht leeren String hinten an, wenn dieses
 * noch nicht vorhanden ist
 */
function apxAddChar( $s, $c ) {
    if( !( $length = strlen( $s ) ) )
        return $s;

    if( substr( $s, $length - 1 ) != $c )
        return $s.$c;
    else
        return $s;
}

/* 
 * decimal format conversion: european (comma) to international (dot)
 */
function apxNumEuro2Intl( $number ) {
	// remove fullstop, spaces and change comma to fullstop
    return str_replace(',', '.', str_replace(' ', '', str_replace('.', '', $number))); 
}

/* outCur outputs a currency in the standard form
 * format = l ... Waehrungssymbol steht links  vom Wert
 *          r ...                      rechts
 *         (n)...                      nirgends
 */
function apxOutCur( $sCurStr, $val, $format = 'r' ) {
    return ( $format == 'l' ? $sCurStr.' ' : '' ).
           ( ( $val - round( $val ) ) == 0 ? 
           		round( $val ).$GLOBALS['apx_decimal_point'].'&minus;' : 
           		number_format( $val, 2, $GLOBALS['apx_decimal_point'], $GLOBALS['apx_thousands_sep'] ) 
           ).
           ( $format == 'r' ? ' '.$sCurStr : '' );
}

/*
 * Diese Funktion erzeugt eine der Einstellung entsprechende
 * Mail-Url.
 */
function apxCreateMailURL( $sMail_address, $iCustomer_id, $sPhpscript,
                        $sMailerType, $sImgPath, $bUseStdMailSig, $sStdMailSig,
                        $sUserMailSig, $sStdSubject, $bFullHTML = false,
                        $sURLSuffix = '' ) {
    $sMailURL = '';
    $sMailSig = '';
    $sMailSubject = $sStdSubject;

    if ( $bUseStdMailSig )
        $sMailSig = urlencode($sStdMailSig);
    else
        $sMailSig = urlencode($sUserMailSig);

    if( $sMailerType == "mailer_browser_equal" ) {
        $sMailURL = 'mailto:'.$sMail_address;
    }
    else if( $sMailerType == "mailer_browser_notequal" ) {
        $sMailURL = 'mailto:'.$sMail_address.',subject='.$sMailSubject.
                    ',body='.$sMailSig;
        //$sMailURL = $sPhpscript.'?apx_a=exec_ext_mailer&mail_url='.$sMail_address;
    }
    else if( $sMailerType == "internal_mailer" ) {
        $sMailURL = $sPhpscript.'?apx_a=create_cusmail&customer_id='.
                    $iCustomer_id.$sURLSuffix;
    }

    if( $bFullHTML )
        return '<a href="'.$sMailURL.'"><img src="'.
               $sImgPath.'sym_email.gif" align="middle" title="'._( "Send e-mail ..." ).'"></a>
               &nbsp;<a href="'.$sMailURL.'">'.$sMail_address.' ...</a>';
    else
        return $sMailURL;
}

?>
