<?php // $Id: act_proc_config.php,v 1.28 2004/10/11 10:42:42 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required files:
 * -
 *
 * Parameter:
 * - $apx_debug_config - ggf. fuer Debuggingausgaben setzen
 */

/*
 * Konfigurationen speichern oder holen
 */

if( !isset( $apx_debug_config ) )
    $apx_debug_config = false;

$apx_configfile = 'apx_config.php';

require_once( './act_lib.php' );

// Fehlerbehandlung
error_reporting( 0 | ( E_ALL ^ E_NOTICE ) );
set_error_handler( 'apxMsg' );

require_once( './db/data.php' );

// Spezielle Sicherheitsmassnahme, aber nur auf niedrigem Niveau!
// Wenn diese Var. nicht gesetzt ist, wird das skript
// Wurde diese Datei direkt aufgerufen?
if( strstr( $_SERVER[ 'SCRIPT_NAME' ], 'act_proc_config' ) ) {
    // nur moeglich wenn keine Konfigurationsdatei existiert!
    if( file_exists( $apx_configfile ) ) {
        trigger_error( _( "A configuration file is already existing. This request cannot be executed!" ),
                       E_USER_ERROR );
    }
}

apxIsPost( 'apx_auth_usertype', 'apx_auth_usertype', 5 );
if( $apx_auth_usertype != 0 &&
    $_GET[ 'apx_a' ] == 'savecfg' ) {
    $_GET[ 'apx_a' ] = 'getcfg';

    // Keinen Zugriff zu dieser Fuseaction
    trigger_error( $apx_errors[ 11 ], E_USER_WARNING );

    $bAccess = false;
}

// Parameter ueberpruefen
apxIsGet( 'apx_a', 'sConfigaction', 'getcfg' );

switch( $sConfigaction ) {
    case 'savecfg':

        $iCfgFile = fopen( $apx_configfile, 'w' );

        if( !$iCfgFile ) {
            trigger_error( $apx_errors[ 22 ], E_USER_ERROR );
        }

        $aCfgData = array();

        // Spezialbehandlung: Konfig.variablen mit Ausnahmen
        // Zuordnung: Konfig.variable und oblig. letztes Zeichen, welches
        // notfalls angehaengt werden muss
        $a_cfgval_addchar = array(
            'apx_dbbackuppath'  => '/',
            'apx_url'           => '/',
            'apx_imgpath'       => '/',
            'apx_mailpath'      => '/',
            'apx_outputpath'    => '/'
        );

        // Felder, die nicht gespeichert werden sollen
        $a_cfgval_notsave = array(
            'standalonecfg'     => '',
            'apx_auth_usertype' => '',
            'submit'            => '',
            'reset'             => ''
        );

        // Enthaelt Formularfelder, welche nicht immer existieren
        $a_cfgval_checkboxes = array(      // default, processed
            'apx_user_stdmailsig'      => array( 0, false ),
            'apx_spanplan'             => array( 0, false ),
            'apx_plan_shortdesc'       => array( 0, false ),
            'apx_plan_emptyspaces'     => array( 'connect', false ),
            'apx_webplan_active'       => array( 0, false ),
            'apx_inquiry_active'       => array( 0, false ),
            'apx_window_autosize'      => array( 0, false ),
            'apx_customer_quickchoice' => array( 0, false ),
        );

        // JSON Paket vorbereiten
        reset( $_POST );
        while( $a_curpair = each( $_POST ) ) {
            if( !array_key_exists( $a_curpair[ 0 ], $a_cfgval_notsave ) ) {
                $$a_curpair[ 0 ] = $a_curpair[ 1 ];

                // Spezialbehandlung:
                // 1. Slash anhaengen
                if( array_key_exists( $a_curpair[ 0 ], $a_cfgval_addchar ) ) {
                    $$a_curpair[ 0 ] = apxAddChar( $$a_curpair[ 0 ],
                                                $a_cfgval_addchar[ $a_curpair[ 0 ] ] );
                }

                // 2. Werte die nicht immer existieren (Checkboxen)
                if( array_key_exists( $a_curpair[ 0 ], $a_cfgval_checkboxes ) ) {
                    // Wert existiert also, deshalb in Array anhaken
                    $a_cfgval_checkboxes[ $a_curpair[ 0 ] ][ 1 ] = true;
                }

                $aCfgData[ $a_curpair[ 0 ] ] = $a_curpair[ 1 ];
            }
        }

        // Nicht existierende Konfig.var. mit Standardwerten erzeugen
        reset( $a_cfgval_checkboxes );
        for( $i = 0; $i < count( $a_cfgval_checkboxes ); $i++ ) {
            $a_curpair = each( $a_cfgval_checkboxes );
            if( !$a_curpair[ 1 ][ 1 ] ) {
                // wenn noch nicht geschrieben, dann dyn. Var. erzeugen und schreiben
                $$a_curpair[ 0 ] = $a_curpair[ 1 ][ 0 ];

                $aCfgData[ $a_curpair[ 0 ] ] = $a_curpair[ 1 ][ 0 ];
            }
        }

        // JSON Paket erstellen
        $sCfgData = json_encode( $aCfgData );

        // Doppelte Backslashes entfernen
        $sCfgData = str_replace( '\\\\', Chr( 92 ), $sCfgData );

        fwrite( $iCfgFile, "<?php /* \n".$sCfgData."\n*/ ?>" );
        fclose( $iCfgFile );

        /* Break weggelassen, da ja die neue Konfiguration nach dem Speichern
         * sofort wieder ausgelesen werden muss, allerdings sehr imperformant */

    case 'getcfg':  default:
        if( file_exists( $apx_configfile ) ) {
            $iCfgFile = fopen( $apx_configfile, 'r' );
            $sCfgData = fread( $iCfgFile, filesize( $apx_configfile ) );
            fclose( $iCfgFile );

            // PHP Kommentar entfernen
            $sCfgData = str_replace( "<?php /*", '', $sCfgData );
            $sCfgData = str_replace( "*/ ?>", '', $sCfgData );

	    if( $apx_debug )
		echo "config orig: <pre>".$sCfgData."</pre>";
			
	    $aCfgData = json_decode( $sCfgData, TRUE );

	    if( $apx_debug )
		echo "config: ".$aCfgData;

            reset( $aCfgData );
            foreach( $aCfgData as $key => $value ) {
                // UTF-8 decoding because wddx de/serialize use this for i/o
                $$key = utf8_decode( $value );
            }
        }
        else {
	    // TODO: folgende Initialisierung wird nur teilweise benoetigt, da Installationformular gekuerzt wurde, ueberarbeitung der kompletten Konfigurationsroutine empfehlenswert, mehr mit assoziativen Arrays arbeiten.
            // Variablen mit besonderen Defaultwerten setzen,
            // wenn Konfigdatei noch nicht existiert
            $apx_dbserver               = 'localhost:3306';
            $apx_db                     = 'applanix';
            $apx_dbsys                  = 'mysqli';
            $apx_dbuser                 = 'applanix';
            $apx_dbpw                   = 'applanix';
            $apx_dbtableprefix          = 'apx_';
            $apx_dbbackuppath           = 'a:/';
            $apx_url                    = 'http://'.$_SERVER[ 'HTTP_HOST' ].$_SERVER[ 'REDIRECT_URL' ].'/';
            $apx_imgpath                = './img/';
            $apx_mailpath               = './mailbackups/';
            $apx_bill_template          = 'standard.apv';
            $apx_bill_template_selfuse  = 'buchhaltung.apv';
            $apx_bill_template_agency   = 'reisebuero.apv';
            $apx_bill_template_prepaymentonly = 'vorauszahlung.apv';
            $apx_bill_template_guestcard = 'gaestekarte.apv';
            $apx_bill_template_guestinfo = 'infoblatt.apv';
            $apx_outputpath             = '/temp/';
            $apx_outputfilename         = _( 'labels' );
            $apx_user_country           = 1; // Laendernr nach Verzeichnis
            $apx_user_url               = 'http://';
            $apx_user_stdmailsig        = 1;
            $apx_user_ortstaxe          = 1.5; // 1,50 Eur Ortstaxe per person and day
            $apx_std_entrytype          = 1;
            $apx_stddos_b               = 2;
            $apx_stddos_e               = 33;
            $apx_plan_shortdesc         = 1;
            $apx_curstring              = 'Euro';
            $apx_planfontsize           = '8';
            $apx_planmonres             = 1;
            $apx_plan_emptyspaces       = 'connect';
            $apx_spanplan               = 1;
            $apx_use_extern_mailer      = 'internal_mailer';
            $apx_external_mailer        = 'c:\\programme\\mozilla\\mozilla.exe -compose to=';
            $apx_gc_oestat              = 1;
            $apx_gc_betriebnr           = 1;
        }
        break;
}

if( isset( $_POST[ 'standalonecfg' ] ) ) {
    apxIsGet( 'lang', 'apx_deflang', 'C' ); // fuer Installation
    $bSetLocales = setlocale( LC_ALL,
                              ( strstr( PHP_OS, 'WIN' ) ?
                                $apx_languages[ $apx_deflang ][ 0 ] :
                                $apx_deflang ) );
    putenv( "LC_ALL=".$apx_deflang );
    bindtextdomain( "messages", "./locale" );
    textdomain( "messages" );

    echo '<html><body><basefont face="arial" size="9pt" />
          <p align="center"><br/><br/><br/><strong>'.
          _( "Further installation steps" ).':</strong><br /><ol>';

    if ( $apx_dbsys == 'mysqli' )
          echo '<li><a href="'.$apx_url.'act_create_mysql_db.php" target="_blank">'.
          _( "Install MySQL applanix database</a> (only with first installation!)" ).
          '</li>';

    echo  '<li><a href="'.$apx_url.'">'.
          _( "Start mg.applanix now" ).'</a><br />'.
          _( "(IMPORTANT: You have to log in now. Use 'admin' as login and 'applanix' as password. Please change these data immediately or create another active root user and delete this one (the 'Initial Administrator'). If you are using an already existing applanix 1.3 database you can log in as usual. See README for details concerning upgrades!)" ).
          '</li>
          </ol></p></body></html>';
}

if( $apx_debug_config ) {
    echo '<pre>';
    print_r( $_POST );
    echo '</pre>';
    phpinfo();
}

?>
